/* client.c */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <unistd.h>

#define N_TIMES 42
#define BUFFER_SIZE 2000000
char buf[BUFFER_SIZE];

double time_diff(struct timeval x , struct timeval y)
{
    double x_ms , y_ms , diff;
     
    x_ms = (double)x.tv_sec*1000000 + (double)x.tv_usec;
    y_ms = (double)y.tv_sec*1000000 + (double)y.tv_usec;
     
    diff = (double)y_ms - (double)x_ms;
     
    return diff;
}

int main( int argc, char *argv[]) {
  	int port = 8888;
  	char *ip = "192.168.1.1";
  
    struct sockaddr_in server;
    int sock;

    sock = socket( AF_INET, SOCK_STREAM, 0 );

    if (sock < 0) {
        printf("Error: can't create socket\n");
      	return 1;
    }
	
  	bzero(&server, sizeof server);
  	server.sin_family = AF_INET;
    server.sin_port = htons(port);
    inet_pton(AF_INET, ip, &(server.sin_addr));
  
    if(connect(sock,(struct sockaddr*)&server,sizeof(server)) <0) {
        printf("Error: can't connect to server\n");
      	return 1;
    }
  
  	printf("Connected!\n");
	
  	int ns, nr, size = 1, i;
  	struct timeval before , after;
  	double sum, tmp;
  	double min = 999999999;
  	while (size <= 1048576) {
      	sum = 0;
		min = 999999999;
      
      	for (i = 0; i < N_TIMES; i++) {
          	ns = 0;
	      	nr = 0;
          	gettimeofday(&before , NULL);
            ns = send(sock, buf, size, 0);
            do {
                nr += recv(sock, buf, BUFFER_SIZE, 0);
            } while (nr < size);
            gettimeofday(&after , NULL);
	        tmp = time_diff(before , after);
			sum += tmp;
          
          	if (tmp < min) {
              	min = tmp;
            }
           // printf("NS=%i NR=%i; Total time elapsed : %.0lf us\n" , ns, nr, tmp); 
        }
		
      	double mbs = (((double) N_TIMES * size) / ((double) sum * 1e-6)) / (1000.0*1000.0);
      	//printf("%i bytes: DUR=%f (%f MB/s)\n", size, sum, mbs); 
      	printf("(%i, %.2f) %% MB/s, took %f us to transmit %i bytes \n", size, mbs, sum, (N_TIMES * size)); 
      
      	double min_mbs = (((double) size) / ((double) min * 1e-6)) / (1000.0*1000.0);
		printf("   (%i, %.2f) %% MB/s, took %f us to transmit %i bytes \n", size, min_mbs, min, size); 
      
      
      	size = size*2;
    }
  
  
	close(sock);
    return EXIT_SUCCESS;
}