#include <stdio.h>
#include <sys/socket.h>
#include <arpa/inet.h> //inet_addr
#include <sys/socket.h>

#define BUFFER_SIZE 2000000
char buf[BUFFER_SIZE];
  
int main(int argc , char *argv[]) {
  	int port = 8888;
  	
  	struct sockaddr_in server, client;
	int server_fd = socket(AF_INET, SOCK_STREAM, 0);
  	
  	if (server_fd < 0) {
    	printf("Error: could not create socket!\n");
      	return 1;
    }

	server.sin_family = AF_INET;
    server.sin_port = htons(port);
	server.sin_addr.s_addr = htonl(INADDR_ANY);

  	//int opt_val = 1;
	//setsockopt(server_fd, SOL_SOCKET, SO_REUSEADDR, &opt_val, sizeof opt_val);

	if (bind(server_fd, (struct sockaddr *) &server, sizeof(server)) < 0) {
    	printf("Error: could not bind socket!\n");
      	return 1;
    }

	if (listen(server_fd, 128) < 0) {
      	printf("Error: could not listen on socket\n");
      	return 1;
    }
	
  	printf("Echo server is waiting on %d ...\n", port);
  	
  	int client_fd;
	while (1) {
      	socklen_t client_len = sizeof(client);
    	client_fd = accept(server_fd, (struct sockaddr *) &client, &client_len);

    	if (client_fd < 0) {
          	break;
        }
      
      	printf("Connected to new client at %d.%d.%d.%d\n",
        	client.sin_addr.s_addr & 0xff,
            (client.sin_addr.s_addr >> 8) & 0xff,
      		(client.sin_addr.s_addr >> 16) & 0xff,
      		(client.sin_addr.s_addr >> 24) & 0xff);
      

        while (1) {
          	int read = recv(client_fd, buf, BUFFER_SIZE, 0);

          	if (!read) {
          	  break;
          	}

          	if (read < 0) {
          	  printf("Error: client read failed\n");
          	}

          	if (send(client_fd, buf, read, 0) < 0) {
          	  printf("Error: client write failed\n");
          	}
        } 
    }
  
  	return 0;
}